VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Using RTSXQuery DLL in VB 6"
   ClientHeight    =   5220
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8175
   LinkTopic       =   "Form1"
   ScaleHeight     =   5220
   ScaleWidth      =   8175
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame2 
      Caption         =   "Vouchers"
      Height          =   2895
      Left            =   3720
      TabIndex        =   1
      Top             =   600
      Width           =   4095
      Begin VB.CommandButton Command2 
         Caption         =   "Fetch/Update Vouchers"
         Height          =   375
         Left            =   1080
         TabIndex        =   8
         Top             =   2040
         Width           =   2055
      End
      Begin VB.Label lblAltered_Error 
         Caption         =   "0"
         Height          =   255
         Left            =   3600
         TabIndex        =   11
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label lblCreated_Error 
         Caption         =   "0"
         Height          =   255
         Left            =   3600
         TabIndex        =   10
         Top             =   480
         Width           =   615
      End
      Begin VB.Label Label4 
         Caption         =   "Errors:"
         Height          =   255
         Left            =   3000
         TabIndex        =   7
         Top             =   1080
         Width           =   495
      End
      Begin VB.Label Label3 
         Caption         =   "Errors:"
         Height          =   255
         Left            =   3000
         TabIndex        =   6
         Top             =   480
         Width           =   495
      End
      Begin VB.Label lblAltered 
         Caption         =   "0"
         Height          =   255
         Left            =   2040
         TabIndex        =   5
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label lblCreated 
         Caption         =   "0"
         Height          =   255
         Left            =   2040
         TabIndex        =   4
         Top             =   480
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "No. of Vouchers altered"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   1080
         Width           =   1935
      End
      Begin VB.Label Label1 
         Caption         =   "No. of Vouchers added"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   1935
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Masters"
      Height          =   2895
      Left            =   360
      TabIndex        =   0
      Top             =   600
      Width           =   3135
      Begin VB.CommandButton Command1 
         Caption         =   "Fetch Masters"
         Height          =   375
         Left            =   480
         TabIndex        =   14
         Top             =   2040
         Width           =   1935
      End
      Begin VB.Label lblMasters_Error 
         Caption         =   "0"
         Height          =   255
         Left            =   2040
         TabIndex        =   16
         Top             =   1080
         Width           =   615
      End
      Begin VB.Label lblMasters_Created 
         Caption         =   "0"
         Height          =   255
         Left            =   2160
         TabIndex        =   15
         Top             =   600
         Width           =   495
      End
      Begin VB.Label Label6 
         Caption         =   "Errors :"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   1080
         Width           =   735
      End
      Begin VB.Label Label5 
         Caption         =   "No. of Masters added"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   600
         Width           =   1935
      End
   End
   Begin VB.Label lblStatus 
      AutoSize        =   -1  'True
      Caption         =   "Status"
      Height          =   195
      Left            =   240
      TabIndex        =   9
      Top             =   4680
      Width           =   450
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim oRTSlink As RTSlink           'Provides Tally to XML functionality
Dim oRTSXQuery As RTSXQuery       'Provides XML to Database functionality
Dim oRTSMisc As RTSMisc           'Provides General functions
Dim strConnectionString As String
Dim strRTSXQueryPATH As String
'RTS
Dim bDebug As Boolean

Private Sub Form_Load()
    'RTS
    bDebug = True

    '=======================================================================================================
    'TO DO - START
    '=======================================================================================================
    'You must include reference to "C:\RTSXQuery_LibV1.0\RTSXQuery_lib.dll" file using option "Project >> Reference >> Browse"
    '
    '
    'Specify the ConnectionString to connect to your database
    'Subsitute the value in the connection sring   Source= SHWETASOFTWARES\\SQLEXPRESS
    strConnectionString = "Provider=sqloledb;Data Source=SHWETASOFTWARES\SQLEXPRESS;Initial Catalog=Tally;Integrated Security=SSPI;"
    
    'Specify the PATH where RTSXQuery DLL (library) is installed
    strRTSXQueryPATH = "C:\RTSXQuery_LibV1.0\"
    
    '=======================================================================================================
    'TO DO - END
    '=======================================================================================================
    
    Set oRTSlink = New RTSlink
    Set oRTSXQuery = New RTSXQuery
    Set oRTSMisc = New RTSMisc
End Sub

Private Sub Command1_Click()
    'Path where RTSXQuery is installed
    oRTSMisc.RTSXQueryPATH = strRTSXQueryPATH
    
    'Check whether Tally is running
    If (oRTSlink.Open() <> 0) Then
        MsgBox (oRTSlink.LastErrorMessage)
        Exit Sub
    End If


    'Add Masters to sql-database
    Command1.Enabled = False
    ProcessMasters
    Command1.Enabled = True
    MsgBox ("Process Completed")

End Sub

Private Sub Command2_Click()
    'Path where RTSXQuery is installed
    oRTSMisc.RTSXQueryPATH = strRTSXQueryPATH
    
    'Check whether Tally is running
    If (oRTSlink.Open() <> 0) Then
        MsgBox (oRTSlink.LastErrorMessage)
        Exit Sub
    End If

    'Add vouchers to sql-database         (i.e. the newly created vouchers in Tally after last synchronize are added to sql-database)
    'Update vouchers in sql-database      (i.e. only those vouchers which have been altered in Tally after last synchronize)
    Command2.Enabled = False
    ProcessVouchers
    Command2.Enabled = True
    MsgBox ("Process Completed")
End Sub
Private Sub ProcessVouchers()

    Dim lLastVchID As Integer
    Dim lLastAlterID As Integer
    Dim lLastError As Integer
    
    Dim XQueryFileToPushMainVoucherTableData As String
    Dim XQueryFileToPushOtherVoucherTablesData As String
    Dim XQueryFileToDeleteVouchersData As String
    Dim strXMLResponse As String
    
    'XQuery files
    XQueryFileToPushMainVoucherTableData = strRTSXQueryPATH + "xquery-push-vouchers-main-table-into-database.xq"
    XQueryFileToPushOtherVoucherTablesData = strRTSXQueryPATH + "xquery-push-vouchers-other-tables-into-database.xq"
    XQueryFileToDeleteVouchersData = strRTSXQueryPATH + "xquery-delete-vouchers-from-database.xq"

    'Connection string assigned to Class object
    oRTSXQuery.ConnectionString = strConnectionString

    'Get the Last Voucher Id (VchID) from Table "vchmain". Returns -1 if table does not exist.
    lLastVchID = oRTSXQuery.GetFieldMaxValue("vchmain", "vchid")

    'Get the Last Alter Id (AlterID) from table "vchmain".  Returns -1 if table does not exist.
    lLastAlterID = oRTSXQuery.GetFieldMaxValue("vchmain", "alterid")
    If (lLastAlterID = -1) Then
        lLastAlterID = 0
    End If
    

    '===================================================
    'STEP 1 - CreateVouchers
    '===================================================
    'Step 1a - Tally to XML - Get the newly created vouchers from Tally which do not exist in Main-table "vchmain"

    lblStatus.Caption = "Retrieve Voucher data from Tally..."
    lblStatus.Refresh
    strXMLResponse = TallyToXML(lLastVchID, -1)
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    
    'Convert some tags to upper case
    strXMLResponse = ConvertSomeXMLTagsToUpperCase(strXMLResponse)
    
    lblStatus.Caption = "Send data to main table..."
    lblStatus.Refresh
    
    'RTS
    If bDebug = True Then
        'Log XML to file
        Call oRTSMisc.WriteTextFile(".\vouchers-new.xml", strXMLResponse)
    End If
    
    
    'Step 1b - XML to database - Transfer data to table "Vchmain"
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushMainVoucherTableData)
    
    'You must Place two labels on the form viz a) lblCreated  b) lblCreated_Error
    lblCreated.Caption = Str(oRTSXQuery.RowsAffected)
    lblCreated_Error.Caption = Str(oRTSXQuery.ErrorCount)

    'If any error relating to "File Not found" occurs, then
    lLastError = oRTSXQuery.LastErrorNumber
    If ((lLastError > 0) And (lLastError < 1000)) Then
        MsgBox (Str(oRTSXQuery.LastErrorNumber))
        Exit Sub
    End If
    
    lblStatus.Caption = "Send data to other tables database..."
    lblStatus.Refresh
    
    'Step 1c - XML to database - Transfer data to Other tables
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushOtherVoucherTablesData)

    '===================================================
    'STEP 2 - UpdateVouchers (Method: Delete & Insert)
    '===================================================
    'Steps 2a and 2b will delete vouchers from database which were altered in Tally
    '------------------------------------------------------------------------------
    'Step 2a - Get all vouchers-data into strXMLResponse which have been altered in Tally since last synchronize
    strXMLResponse = TallyToXML(lLastVchID, lLastAlterID)
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If

    'Convert some tags to upper case
    strXMLResponse = ConvertSomeXMLTagsToUpperCase(strXMLResponse)

    lblStatus.Caption = "Update all such records in database which have been modified in Tally after last syn..."
    lblStatus.Refresh
    'Step 2b - Delete voucher from database (only those vouchers which were altered in Tally)
    Call XMLToDatabase(strXMLResponse, XQueryFileToDeleteVouchersData)

    'Step 2c - Insert vouchers into Main table (only those vouchers which were altered in Tally)
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushMainVoucherTableData)
    'You must Place two labels on the form viz a) lblAltered  b) lblAltered_Error
    lblAltered.Caption = Str(oRTSXQuery.RowsAffected)
    lblAltered_Error.Caption = Str(oRTSXQuery.ErrorCount)

    'Step 2d - XML to database - Other tables (only those vouchers which were altered in Tally)
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushOtherVoucherTablesData)

End Sub
Private Function TallyToXML(ByVal lLastVchID As Integer, ByVal lLastAlterID As Integer) As String
    'Tally to XML - Invoked from ProcessVouchers()
    Dim lResult As Integer
    Dim strXMLRequest As String
    Dim strXMLResponse As String

    strXMLRequest = oRTSMisc.ReadTextFile(strRTSXQueryPATH + "XMLRequest-pull-vouchers-from-tally.xml")
    strXMLResponse = ""

    strXMLRequest = oRTSMisc.StrReplace(strXMLRequest, "##LASTVCHID##", Str(lLastVchID))
    strXMLRequest = oRTSMisc.StrReplace(strXMLRequest, "##LASTALTERID##", Str(lLastAlterID))

    'Send Request to Tally
    lResult = oRTSlink.Send(strXMLRequest)

    'Get Response
    If (lResult = 0) Then
        strXMLResponse = oRTSlink.GetResponse
        TallyToXML = strXMLResponse
    Else
        MessageBox.Show (oRTSlink.LastErrorMessage)
        TallyToXML = ""
    End If


End Function

Private Sub XMLToDatabase(ByVal strXMLResponse As String, ByVal XQueryPushVouchersFileName As String)
    'XML to Database - Invoked from ProcessVouchers()
    Dim strXQueryResult As String
    Dim strLastErrorMessage As String
    Dim lLastErrorNumber As Integer
    
    oRTSXQuery.XML = strXMLResponse
    oRTSXQuery.XQueryFromFile = XQueryPushVouchersFileName

    'Execute query
    oRTSXQuery.SuppressCreateTableErrors = False
    strXQueryResult = oRTSXQuery.Execute

    strLastErrorMessage = oRTSXQuery.LastErrorMessage
    lLastErrorNumber = oRTSXQuery.LastErrorNumber

    If IsNull(strLastErrorMessage) Then
        If (Len(strLastErrorMessage) > 0) Then
            MsgBox ("Error No: " + Str(lLastErrorNumber) + "\n" + strLastErrorMessage)
        End If
    End If
    

End Sub


Private Sub ProcessMasters()
    Dim lLastMasterID As Integer
    Dim lMastersCreated As Integer
    Dim lMastersCreated_Error As Integer
    
    Dim XQueryFileToPushLedgerMasterTableData As String
    Dim XQueryFileToPushGroupsMasterTableData As String
    Dim XQueryFileToPushCostCentresMasterTableData As String
    Dim XQueryFileToPushUnitMasterTableData As String
    Dim XQueryFileToPushStockGroupMasterTableData As String
    Dim XQueryFileToPushGodownMasterTableData As String
    Dim XQueryFileToPushStockItemMasterTableData As String
    Dim strSQL As String
    Dim lLastError As Integer
    Dim strXMLResponse As String

    'XQuery files
    XQueryFileToPushLedgerMasterTableData = strRTSXQueryPATH + "xquery-push-masters-ledgers-into-database.xq"
    XQueryFileToPushGroupsMasterTableData = strRTSXQueryPATH + "xquery-push-masters-groups-into-database.xq"
    XQueryFileToPushCostCentresMasterTableData = strRTSXQueryPATH + "xquery-push-masters-costcentres-into-database.xq"
    XQueryFileToPushUnitMasterTableData = strRTSXQueryPATH + "xquery-push-masters-unit-into-database.xq"
    XQueryFileToPushStockGroupMasterTableData = strRTSXQueryPATH + "xquery-push-masters-stockgroup-into-database.xq"
    XQueryFileToPushGodownMasterTableData = strRTSXQueryPATH + "xquery-push-masters-godown-into-database.xq"
    XQueryFileToPushStockItemMasterTableData = strRTSXQueryPATH + "xquery-push-masters-stockitem-into-database.xq"

    'Connection string assigned to Class object
    oRTSXQuery.ConnectionString = strConnectionString

    'Ledger Master
    '===================================================================================
    'Get the Last MASTERID from Table "masterledger". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve Ledger Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("masterledger", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$parent,@@AcctGroupID,$openingbalance,$alteredon from Ledger where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    
    'RTS
    If bDebug = True Then
        'Log XML to file
        Call oRTSMisc.WriteTextFile(".\" & Trim("MasterLedger") & ".xml", strXMLResponse)
    End If
    
    
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert Ledger Master data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushLedgerMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)

    'If any error relating to "File Not found" occurs, then
    lLastError = oRTSXQuery.LastErrorNumber
    If (lLastError > 0) And (lLastError < 1000) Then
        MsgBox (Str(oRTSXQuery.LastErrorNumber))
    End If
            
    '===================================================================================
    'Group Master
    '===================================================================================
    'Get the Last MASTERID from Table "mastergroups". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve Group Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("mastergroups", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$parent,$isrevenue,$isdeemedpositive,$alteredon from Groups where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert Group Master data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushGroupsMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)
    '===================================================================================


    '===================================================================================
    'CostCentre Master
    '===================================================================================
    'Get the Last MASTERID from Table "mastercostcentres". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve CostCentre Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("mastercostcentres", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$parent from CostCentres where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert CostCentre Masters data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushCostCentresMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)


    '===================================================================================
    'UNIT Master
    '===================================================================================
    'Get the Last MASTERID from Table "masterunit". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve UNIT Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("masterunit", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$formalname,$decimalplaces,$alteredon from UNIT where $masterid &gt; $$Number:\"" + Str(lLastMasterID) + """""
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert UNIT Masters data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushUnitMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)

    '===================================================================================
    'StockGroup Master
    '===================================================================================
    'Get the Last MASTERID from Table "masterstockgroup". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve StockGroup Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterStockGroup", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$parent,$$alias,$alteredon from StockGroup where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert StockGroup Masters data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushStockGroupMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)

    '===================================================================================
    'Godown Master
    '===================================================================================
    'Get the Last MASTERID from Table "masterGodown". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve Godown Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterGodown", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$parent,$$alias,$alteredon from Godown where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert Godown Masters data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushGodownMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)

    '===================================================================================
    'StockItem Master
    '===================================================================================
    'Get the Last MASTERID from Table "masterStockItem". Returns -1 if table does not exist.
    lblStatus.Caption = "Retrieve StockItem Master data from Tally.."
    lblStatus.Refresh
    lLastMasterID = oRTSXQuery.GetFieldMaxValue("MasterStockItem", "masterid")
    'Step 1- Tally to XML
    strSQL = "Select $masterid,$name,$$alias,$parent,@@StockGroupId,$mailingname,$mailingname, " _
             & "$category,$narration,$description,$baseunits,@@BaseUnitsId,$costingmethod,$valuationmethod, " _
             & "$$Number:$openingbalance,$openingvalue,$$Number:$openingrate,$alteredon from StockItem where $masterid &gt; $$Number:""" + Str(lLastMasterID) + """"
    Call oRTSlink.SQLRequest(strSQL, "")
    strXMLResponse = oRTSlink.GetResponse()
    If (Len(strXMLResponse) = 0) Then
        Exit Sub
    End If
    'Step 2 - XML to Database
    lblStatus.Caption = "Insert StockItem Masters data into database.."
    lblStatus.Refresh
    Call XMLToDatabase(strXMLResponse, XQueryFileToPushStockItemMasterTableData)
    lMastersCreated = lMastersCreated + oRTSXQuery.RowsAffected
    lMastersCreated_Error = lMastersCreated_Error + oRTSXQuery.ErrorCount
    Call MastersCount(lMastersCreated, lMastersCreated_Error)
        

End Sub

Private Sub MastersCount(ByVal lMastersCreated As Integer, ByVal lMasters_Error As Integer)
    'You must Place two labels on the form viz a) lblMasters_Created  b) lblMasters_Error
    lblMasters_Created.Caption = Str(lMastersCreated)
    lblMasters_Error.Caption = Str(lMasters_Error)
    lblMasters_Created.Refresh
    lblMasters_Error.Refresh
End Sub

Private Function ConvertSomeXMLTagsToUpperCase(ByVal strXMLResponse As String)
    strXMLResponse = Replace$(strXMLResponse, "Voucher ", "VOUCHER ")
    strXMLResponse = Replace$(strXMLResponse, "</Voucher>", "</VOUCHER>")
    strXMLResponse = Replace$(strXMLResponse, "Date", "DATE")
    strXMLResponse = Replace$(strXMLResponse, "VoucherTypeName", "VOUCHERTYPENAME")
    strXMLResponse = Replace$(strXMLResponse, "VoucherNumber", "VOUCHERNUMBER")
    strXMLResponse = Replace$(strXMLResponse, "PartyName", "PARTYNAME")
    strXMLResponse = Replace$(strXMLResponse, "PartyLedgerName", "PARTYLEDGERNAME")
    strXMLResponse = Replace$(strXMLResponse, "Reference", "REFERENCE")
    strXMLResponse = Replace$(strXMLResponse, "Narration", "NARRATION")
    strXMLResponse = Replace$(strXMLResponse, "LedgerName", "LEDGERNAME")
    strXMLResponse = Replace$(strXMLResponse, "Amount", "AMOUNT")
    strXMLResponse = Replace$(strXMLResponse, "ActualQty", "ACTUALQTY")
    strXMLResponse = Replace$(strXMLResponse, "CreatedBy", "CREATEDBY")
    strXMLResponse = Replace$(strXMLResponse, "AlteredBy", "ALTEREDBY")
    strXMLResponse = Replace$(strXMLResponse, "AlteredOn", "ALTEREDON")
    strXMLResponse = Replace$(strXMLResponse, "IsOptional", "ISOPTIONAL")
    strXMLResponse = Replace$(strXMLResponse, "IsCancelled", "ISCANCELLED")
    
    ConvertSomeXMLTagsToUpperCase = strXMLResponse
End Function

